using System;
using System .Collections .Generic;
using System .Drawing;
using System .Windows .Forms;

namespace Test_MoveGraphLibrary
{
    public partial class Form_HouseConstruction : Form
    {
        SimpleHouse house;
        Font font;
        string [] Cmnts = new string [] { "L_Press",    "to change sizes",  
                                          "L_Press",    "to move the house",
                                          "L_Click",    "to put on top",
                                          "L_DblClick", "to change colors",
                                          "R_Click",    "to save or delete" };

        // -------------------------------------------------
        public Form_HouseConstruction ()
        {
            InitializeComponent ();
        }
        // -------------------------------------------------        OnLoad
        private void OnLoad (object sender, EventArgs e)
        {
            font = new Font ("Times New Roman", 16, FontStyle .Bold | FontStyle .Italic);
            Rectangle rc = new Rectangle (20, 110, 140, 238);
            Point pt = new Point ((rc .Left + rc .Right) / 2, rc .Top - 96);
            Color clrHouse = Color .FromArgb (250, 250, 250);
            Color clrRoof = Color .Red;
            house = new SimpleHouse (17, font, 38, rc, pt, clrHouse, clrRoof);
            house .WindowColor = Color .Blue;
            house .DoorColor = Color .DarkRed;
        }
        // -------------------------------------------------        OnPaint
        private void OnPaint (object sender, PaintEventArgs e)
        {
            Graphics grfx = e .Graphics;
            house .Draw (grfx);

            Rectangle rc = house .Area;
            Point ptTop = house .Top;

            Font fontBold = new Font ("Mictosoft Sens Serif", 8, FontStyle .Bold);
            Font fontOrdinary = new Font ("Mictosoft Sens Serif", 8);
            int cxLabel = rc .Right + rc .Width / 3;
            int cyChangeSizes = (ptTop .Y + rc .Top) / 2;
            int cyMoveHouse = rc .Top + rc .Height / 12;
            int cyChangeColors = (rc .Top + rc .Bottom) / 2;
            SizeF [] sizefLabel = new SizeF [Cmnts .Length / 2];
            int nW_max_Bold = 0;
            for (int i = 0; i < Cmnts .Length / 2; i++)
            {
                sizefLabel [i] = grfx .MeasureString (Cmnts [i * 2], fontBold);
                nW_max_Bold = Math .Max (nW_max_Bold, (int) (sizefLabel [i] .Width));
            }
            int nH_Bold = (int) (sizefLabel [0] .Height);
            int cxComment = cxLabel + nW_max_Bold + 10;
            int cyPutOnTop = cyChangeColors - (nH_Bold + 4);
            int cySaveDelete = cyChangeColors + (nH_Bold + 4);

            SolidBrush brush = new SolidBrush (Color .Black);
            grfx .DrawString (Cmnts [0], fontBold, brush, cxLabel, cyChangeSizes - nH_Bold / 2);
            grfx .DrawString (Cmnts [2], fontBold, brush, cxLabel, cyMoveHouse - nH_Bold / 2);
            grfx .DrawString (Cmnts [4], fontBold, brush, cxLabel, cyPutOnTop - nH_Bold / 2);
            grfx .DrawString (Cmnts [6], fontBold, brush, cxLabel, cyChangeColors - nH_Bold / 2);
            grfx .DrawString (Cmnts [8], fontBold, brush, cxLabel, cySaveDelete - nH_Bold / 2);

            grfx .DrawString (Cmnts [1], fontOrdinary, brush, cxComment, cyChangeSizes - nH_Bold / 2);
            grfx .DrawString (Cmnts [3], fontOrdinary, brush, cxComment, cyMoveHouse - nH_Bold / 2);
            grfx .DrawString (Cmnts [5], fontOrdinary, brush, cxComment, cyPutOnTop - nH_Bold / 2);
            grfx .DrawString (Cmnts [7], fontOrdinary, brush, cxComment, cyChangeColors - nH_Bold / 2);
            grfx .DrawString (Cmnts [9], fontOrdinary, brush, cxComment, cySaveDelete - nH_Bold / 2);

            Pen pen = new Pen (Color .DarkGray);
            int cxLines_R = cxLabel - 6;
            Point ptLT = new Point (rc .Left, rc .Top);
            Point ptRT = new Point (rc .Right, rc .Top);

            Point pt = new Point (cxLines_R, cyChangeSizes);
            grfx .DrawLine (pen, ptTop, pt);
            grfx .DrawLine (pen, ptRT, pt);
            pt = new Point (cxLines_R, cyMoveHouse);
            grfx .DrawLine (pen, pt, new Point ((ptTop .X + ptRT .X) / 2, (ptTop .Y + ptRT .Y) / 2));
            grfx .DrawLine (pen, pt, new Point ((ptLT .X + ptRT .X) / 2, (ptLT .Y + ptRT .Y) / 2));
            grfx .DrawLine (pen, pt, new Point (rc .Right, rc .Top + rc .Height / 4));
            pt = new Point ((rc .Left + rc .Right) / 2, (rc .Top + rc .Bottom) / 2);
            grfx .DrawLine (pen, pt, new Point (cxLines_R, cyPutOnTop));
            grfx .DrawLine (pen, pt, new Point (cxLines_R, cyChangeColors));
            grfx .DrawLine (pen, pt, new Point (cxLines_R, cySaveDelete));
        }
    }
}