using System;
using System .Collections .Generic;
using System .Drawing;
using System .Windows .Forms;

using MoveGraphLibrary;

namespace Test_MoveGraphLibrary
{
    public partial class Form_RegularPolygons : Form
    {
        List<RegularPolygon> polygons = new List<RegularPolygon> ();
        Mover Movers = new Mover ();

        int cyLine;
        string [] strInfo = new string [] { "All polygons are moveable and nonresizable.", 
                                            "Press inside the circles to move.",
                                            "L_DoubleClick and R_DoubleClick for rotation.",
                                            "Rotation angle is 180 / nApex." };

        // -------------------------------------------------
        public Form_RegularPolygons ()
        {
            InitializeComponent ();
        }
        // -------------------------------------------------        OnLoad
        private void OnLoad (object sender, EventArgs e)
        {
            TMGL_Common .OneColumnPanelInfo (this, panelInfo, Font, strInfo, out cyLine);

            RegularPolygon rp4 = new RegularPolygon (0, new Point (100, 100), 50, 4, Auxi_Colours .ColorPredefined (0), Color .Black, Font);
            polygons .Insert (0, rp4);
            Movers .Insert (0, rp4);
            RegularPolygon rp5 = new RegularPolygon (1, new Point (140, 400), 120, 5, Auxi_Colours .ColorPredefined (1), Color .Black, Font);
            polygons .Insert (0, rp5);
            Movers .Insert (0, rp5);
            RegularPolygon rp6 = new RegularPolygon (2, new Point (300, 360), 90, 6, Auxi_Colours .ColorPredefined (2), Color .Black, Font);
            polygons .Insert (0, rp6);
            Movers .Insert (0, rp6);
            RegularPolygon rp7 = new RegularPolygon (3, new Point (310, 120), 100, 7, Auxi_Colours .ColorPredefined (3), Color .Black, Font);
            polygons .Insert (0, rp7);
            Movers .Insert (0, rp7);
            RegularPolygon rp12 = new RegularPolygon (4, new Point (500, 320), 150, 12, Auxi_Colours .ColorPredefined (4), Color .Black, Font);
            polygons .Insert (0, rp12);
            Movers .Insert (0, rp12);

            Movers .Add (panelInfo);
        }
        // -------------------------------------------------        OnPaint_panelInfo
        private void OnPaint_panelInfo (object sender, PaintEventArgs e)
        {
            Graphics grfx = e .Graphics;
            SolidBrush brush = new SolidBrush (Color .Black);
            for (int i = 0; i < strInfo .Length; i++)
            {
                grfx .DrawString (strInfo [i], Font, brush, 0, i * cyLine);
            }
        }
        // -------------------------------------------------        OnPaint
        private void OnPaint (object sender, PaintEventArgs e)
        {
            Graphics grfx = e .Graphics;
            for (int i = polygons .Count - 1; i >= 0; i--)
            {
                polygons [i] .Draw (grfx);
            }
        }
        // -------------------------------------------------        OnMouseDown
        private void OnMouseDown (object sender, MouseEventArgs mea)
        {
            Movers .CatchMover (mea .Location);
        }
        // -------------------------------------------------        OnMouseUp
        private void OnMouseUp (object sender, MouseEventArgs e)
        {
            Movers .ReleaseMover ();
        }
        // -------------------------------------------------        OnMouseMove
        private void OnMouseMove (object sender, MouseEventArgs mea)
        {
            Movers .MovingMover (mea .Location);
            if (Movers .MoverCaught)
            {
                Invalidate ();
            }
        }
        // -------------------------------------------------        OnMouseDoubleClick
        private void OnMouseDoubleClick (object sender, MouseEventArgs mea)
        {
            Point pt = mea .Location;
            foreach (RegularPolygon polygon in polygons)
            {
                if (polygon .Inside (pt))
                {
                    int nTurn = 180 / polygon .Apexes;
                    if (mea .Button == MouseButtons .Left)
                    {
                        polygon .Angle = Auxi_Common .ChangedAngle (polygon .Angle, nTurn);
                        Invalidate ();
                        break;
                    }
                    else if (mea .Button == MouseButtons .Right)
                    {
                        polygon .Angle = Auxi_Common .ChangedAngle (polygon .Angle, -nTurn);
                        Invalidate ();
                        break;
                    }
                }
            }
        }
    }
}