using System;
using System .Collections .Generic;
using System .Drawing;
using System .Windows .Forms;
using MoveGraphLibrary;

namespace Test_MoveGraphLibrary
{
    public partial class Form_SelectNewFunction : Form
    {
        Rectangle [] rc;
        FullGrArea [] area;
        Form formParent;
        int nTypes;
        int iNewFunc = -1;
        Point ptMouseInit;

        // -------------------------------------------------
        public Form_SelectNewFunction (Form formPrnt, Point ptMouseScreen) 
        {
            InitializeComponent ();
            formParent = formPrnt;
            ptMouseInit = ptMouseScreen;
        }
        // -------------------------------------------------        OnLoad
        private void OnLoad (object sender, EventArgs e)
        {
            nTypes = Enum .GetNames (typeof (DemoFuncType)) .Length - 1;
            int nPerRow = 4;
            int nRowStandard = (nTypes - 1) / nPerRow;
            if ((nTypes - 1) % nPerRow != 0) nRowStandard++;
            int nRectSize = PureGrArea .MinSize;
            int nSpace = nRectSize / 3;
            ClientSize = new Size (nRectSize * nPerRow + nSpace * (nPerRow + 1),
                                   nRectSize * nRowStandard + nSpace * (nRowStandard + 1));
            rc = new Rectangle [nTypes];
            for (int i = 0; i < nTypes; i++)
            {
                rc [i] = new Rectangle (nSpace + (i % nPerRow) * (nRectSize + nSpace),
                                        nSpace + (i / nPerRow) * (nRectSize + nSpace), nRectSize, nRectSize);
            }
            area = new FullGrArea [nTypes];
            for (int i = 0; i < nTypes; i++)
            {
                double [] fParam = PlotOnScreen .PredefinedFunctonParams ((DemoFuncType) i);
                area [i] = new FullGrArea (rc [i], Side .S, fParam [0], fParam [1], fParam [2],
                                                   Side .W, fParam [3], fParam [4], fParam [5]);
                area [i] .ShowHorScale = false;
                area [i] .ShowVerScale = false;
                area [i] .ShowTitle = false;
            }
            Point ptLT = Auxi_Common .FormPosition (this, ptMouseInit, 700, 600, 4);
            this .Location = ptLT;  
        }
        // -------------------------------------------------        OnPaint
        private void OnPaint (object sender, PaintEventArgs e)
        {
            Graphics grfx = e.Graphics;
            Pen pen = new Pen (Color .Blue);
            for (int i = 0; i < nTypes; i++)
            {
                grfx .DrawRectangles (new Pen (Color .DarkGray), rc);
            }
            area [0] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Sin), SegmentLocation .Partly_Inside); 
            area [1] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Cos), SegmentLocation .Partly_Inside); 
            area [2] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Tanh), SegmentLocation .Partly_Inside);
            area [3] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Asin), SegmentLocation .Partly_Inside);
            area [4] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Acos), SegmentLocation .Partly_Inside);
            area [5] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Atan), SegmentLocation .Partly_Inside);
            double []fParam = new double [2] { 14, 1 };
            area [6] .DrawYofX (grfx, pen, new Delegate_DblOfArray (Sample_Func .sinAsinB), fParam,
                                SegmentLocation .Partly_Inside);  
            fParam = new double [] { 3, 2, 10 };
            area [7] .DrawYofX (grfx, pen, new Delegate_DblOfArray (Sample_Func .RepeatDampedVibrations), fParam,
                                SegmentLocation .Partly_Inside);  
            fParam = new double [2] { 0.8, 0.5 };
            area [8] .DrawYofX (grfx, pen, new Delegate_DblOfArray (Sample_Func .NormalDistribution), fParam,
                                SegmentLocation .Partly_Inside);  
            area [9] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .ParamFunc_X_0),
                                            new Delegate_DblOfDbl (Sample_Func .ParamFunc_Y_0),
                                            0.0, 29.0, 0.02);  
            area [10] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .ParamFunc_X_1),
                                            new Delegate_DblOfDbl (Sample_Func .ParamFunc_Y_1),
                                            -7.5, 7.5, 0.02);  
            area [11] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .ParamFunc_X_2),
                                            new Delegate_DblOfDbl (Sample_Func .ParamFunc_Y_2),
                                            -4.0, 4.0, 0.01);  
            area [12] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .Lissajou_Param_X),
                                            new Delegate_DblOfDbl (Sample_Func .Lissajou_Param_Y),
                                            0.0, 20.0, 0.02);  
            area [13] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .ParamFunc_X_4),
                                            new Delegate_DblOfDbl (Sample_Func .ParamFunc_Y_4),
                                            -2.5, 2.5, 0.005);  
            area [14] .DrawParamFunc (grfx, pen, new Delegate_DblOfDbl (Sample_Func .ParamFunc_X_5),
                                            new Delegate_DblOfDbl (Sample_Func .ParamFunc_Y_5),
                                            0.0, 6.29, 0.01);  
            area [15] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Sin), SegmentLocation .Partly_Inside); 
            area [15] .DrawYofX (grfx, pen, new Delegate_DblOfDbl (Math .Cos), SegmentLocation .Partly_Inside);
        }
        // -------------------------------------------------        OnMouseMove
        private void OnMouseMove (object sender, MouseEventArgs mea)
        {
            for (int i = 0; i < nTypes; i++)
            {
                if (rc [i] .Contains (mea .Location))
                {
                    Cursor .Current = Cursors .Hand;
                    break;
                }
            }
        }
        // -------------------------------------------------        OnMouseDown
        private void OnMouseDown (object sender, MouseEventArgs mea)
        {
            if (mea .Button == MouseButtons .Left)
            {
                for (int i = 0; i < nTypes; i++)
                {
                    if (rc [i] .Contains (mea .Location))
                    {
                        iNewFunc = i;
                        Close (); 
                    }
                }
            }
        }
        // =================================================        SelectedFunction
        public int SelectedFunction
        {
            get { return (iNewFunc); }
        }

    }
}