using System;
using System .Collections .Generic;
using MoveGraphLibrary;

namespace Test_MoveGraphLibrary
{
    public class PlotOnScreen
    {
        static double [,] fDemoParam = new double [,] { 
                        { -2 * Math.PI, 3 * Math.PI, 1.0,  1.0,  -1.0,  0.5 },      // Sine
                        { -4 * Math.PI, 2 * Math.PI, 2.0,  1.0,  -1.0,  0.5 },      // Cosine
                        { -5,           5,           2.5,  1.0,  -1.0,  0.5 },      // Hiperbolic tangent
                        { -1.0,         1.0,         0.5,  1.6,  -1.6,  0.5 },      // Arcsine
                        { -1.0,         1.0,         0.5,  3.15,  0.0,  1.0 },      // Arccosine
                        { -4.0,         4.0,         0.5,  1.6,  -1.6,  0.5 },      // Arctangent
                        { -4.0,        10.0,         2.5,  1.05, -1.05, 0.5 },      // Sin(14x)*Sin(x)
                        {  0.0,        20.0,         5.0,  3.0,  -3.0,  1.5 },      // Dumped vibrations
                        { -1.0,         3.0,         1.0,  1.5,   0.0,  0.5 },      // Distribution
                        {-20.0,        30.0,        10.0, 30.0, -30.0, 10.0 },      // Parametric_0
                        { -7.5,         7.5,         2.5,  7.5,  -7.5,  2.5 },      // Parametric_1
                        { -1.5,         1.0,         0.5,  5.0,  -5.0,  2.5 },      // Parametric_2
                        { -1.05,        1.05,        0.5,  1.05, -1.05, 0.5 },      // Parametric_3
                        { -5.0,         5.0,         2.0,  4.5,  -2.0,  2.0 },      // Parametric_4
                        { -3.0,         3.0,         1.5,  3.0,  -3.0,  1.5 },      // Parametric_5
                        { -4 * Math.PI, 2 * Math.PI, 2.0,  1.0,  -1.0,  0.5 }       // Trigonometric_0
                       };

        DemoFuncType funcType;
        FullGrArea grArea;

         // -------------------------------------------------        PlotOnScreen
        public PlotOnScreen (DemoFuncType type, FullGrArea area)
        {
            funcType = type;
            grArea = area;
        }
        // -------------------------------------------------        Type
        public DemoFuncType Type
        {
            get { return (funcType); }
            set { funcType = value; }
        }
        // -------------------------------------------------        GrArea
        public FullGrArea GrArea
        {
            get { return (grArea); }
            set { grArea = value; }
        }
        // -------------------------------------------------        PredefinedFunctonParams
        public static double [] PredefinedFunctonParams (DemoFuncType ftype)
        {
            double [] fParam = new double [6];
            if (ftype != DemoFuncType .Arbitrary)
            {
                int i = (int) ftype;
                for (int j = 0; j < 6; j++)
                {
                    fParam [j] = fDemoParam [i, j];
                }
            }
            else
            {
                fParam = new double [6] { -1.0, 1.0, 0.5, 1.0, -1.0, 0.5 };
            }
            return (fParam);
        }
   
    }
}
